﻿################################################################################
## Initialization
################################################################################

init offset = -1

################################################################################
## card list (in menu)
################################################################################

screen cardlist(cards):
    tag menu
    use game_menu(_("Card List"), scroll="viewport"):
        fixed:
            ysize 1250
            grid 4 10:
                spacing 5
                xalign .5
                for i in cards:
                    button:
                        #if i in collection: #gotta add this later, you can unlock cards by fusing them
                        add i.face zoom .5
                        action ShowTransient("showcard", card=i)
                        #else:
                        #    add "card locked" zoom .5
                        #    action None

                #fill in the rest of the grid with blank squares
                for i in range(len(cards), 40):
                    add "card white" zoom .5

#if len(deck)<40:
#you need more cards in your deck to play

################################################################################
## card screens
################################################################################

screen card(card):
    #key "dismiss" action Hide("card") ##breaks the game lol
    #modal True
    frame xysize 350, 500:
        style_group "card"
        background card.type
        label card.name
        add card.face ypos 39
        vbox:
            yoffset 292
            spacing 10
            vbox:
                xoffset 12
                xysize (300, 80)
                text card.info
            hbox:
                xoffset 20
                text _("CUTE:")
                hbox:
                    for i in range(card.cute):
                        add "cutestar"
            hbox:
                xoffset 20
                text _("COOL:")
                hbox:
                    for i in range(card.cool):
                        add "coolstar"
style card_frame:
    xalign .5
    yalign .5
    padding (15,15)

style card_label_text:
    font gui.text_font
    bold True
    size 24
    color "#505050"
style card_text:
    color "#505050"

screen showcard(card):
    #this screen is a variant of the card screen to be shown in the card list/gallery
    modal True
    key "dismiss" action Hide("showcard")
    add Solid("#0008")
    use card(card)

screen checkcard(card):
    #this screen is a variant of the card screen to give you certain menu options while you're in a match
    modal True
    key "game_menu" action Hide("checkcard")
    add Solid("#0008")
    use card(card)
    frame:
        align (.8,.4)
        has vbox

        if card!=fieldcard: #play card button does not appear when you check the active field card in play
            if card.type=="field":
                #since it's a different field card to the one in play, change the field
                textbutton _("Play Field Card") action [SetVariable("fieldcard", card), Jump("changefield")]
            elif card==playcard:
                #play this card against your opponent
                textbutton _("Play Card") action [SetVariable("yourcard", card), SetVariable("fused", False), Hide("checkcard"), Jump("phase2")]
            else:
                #add this card to active slot
                textbutton _("Set Active Card") action [SetVariable("yourcard", card), Hide("checkcard"), Jump("phase1a")]

        textbutton _("Reset Selection") action [SetVariable("chosen1", None), SetVariable("chosen2", None), Hide("checkcard")]
        textbutton _("Cancel") action Hide("checkcard")


screen comparecards(card1, card2):
    frame xysize 1280, 720:
        background None
        hbox:
            align (.3,.1)
            text _("APPEAL:")
            for i in range(appeal):
                add "cutestar"
        hbox:
            align (.7,.1)
            text _("APPEAL:")
            for i in range(theirappeal):
                add "cutestar"
        hbox:
            align (.5,.5)
            spacing 20
            use card(card1)
            use card(card2)

screen hand():
    modal True

    #x = enumerate(yourhand)
    # returns list [(0, trt1), (1,moch1)] etc...
    # yourhand.pop(y) #y being a function to grab x[0]'s position.. so the first half of the tuple

    # a = (0, trt1)
    # a[1] gives you trt1
    hbox:
        align (.5, 1.0)
        spacing 10
        for i in yourhand: #enumerate(yourhand)
            button:

                #############################
                xysize (210,278)

                add str("small_")+i.type
                #add i.type zoom .6

                vbox:
                    pos (9,10)
                    add i.face zoom .6
                    null height 20
                    text _("CUTE: [i.cute]00") xoffset 10
                    null height 10
                    text _("COOL: [i.cool]00") xoffset 10
                #############################

                at cardinhand

                if chosen1:
                    if i==chosen1:
                        action ShowTransient("checkcard", card=i)
                    else:
                        if chosen2:
                            action ShowTransient("checkcard", card=i)
                        else:
                            action SetVariable("chosen2", i)
                else:
                    if i==chosen2:
                        action ShowTransient("checkcard", card=i)
                    else:
                        action SetVariable("chosen1", i)

transform cardinhand:
    yoffset 0
    on hover:
        linear .2 yoffset -10
    on idle:
        linear .2 yoffset 0
    on selected_idle, selected_hover:
        yoffset -10

style field_cardslot_frame:
    background "cardframe"
    xysize (226,322)
    yalign .15
style field_cardslot_label:
    xoffset 10
style field_cardslot_label_text:
    color "#6a5a63"
style field_cardslot_text:
    xoffset 10

screen field():
    modal True
    if fieldcard:
        if fieldcard.value=="MTS1":
            add "field mtsorbet"
    else:
        add "field basic"

    frame:
        style_group "field_cardslot"
        xalign .35
        has vbox
        label _("Active Card")
        if playcard is not None:
            button:
                #same as card button in hand()
                #############################
                xysize (210,278)

                add str("small_")+playcard.type

                vbox:
                    style_group "field_cardslot"
                    pos (9,10)
                    spacing 10
                    add playcard.face zoom .6
                    null height 0
                    text _("CUTE: [playcard.cute]00")
                    text _("COOL: [playcard.cool]00")
                    if fieldcard:
                        if fieldcard.value==advantage.get(playcard.value):
                            text "+2 field bonus!" color "#009bd4"
                #############################

                if chosen1:
                    if playcard==chosen1:
                        action ShowTransient("checkcard", card=playcard)
                    else:
                        action SetVariable("chosen2", playcard)
                else:
                    if playcard==chosen2:
                        action ShowTransient("checkcard", card=playcard)
                    else:
                        action SetVariable("chosen1", playcard)

    frame:
        style_group "field_cardslot"
        xalign .65
        has vbox
        label _("Current Field")
        if fieldcard is not None:
            button:
                #############################
                xysize (210,278)

                add str("small_")+fieldcard.type

                vbox:
                    style_group "field_cardslot"
                    pos (9,10)
                    spacing 10
                    add fieldcard.face zoom .6
                    null height 0
                    text _("CUTE: [fieldcard.cute]00")
                    text _("COOL: [fieldcard.cool]00")
                #############################

                action ShowTransient("checkcard", card=fieldcard)

    frame:# xysize 260, 150:
        xalign .06
        yalign .06
        xminimum 280
        padding (15,15)
        has vbox
        label _("Select cards to fuse.")
        if chosen1:
            textbutton chosen1.name:
                action ShowTransient("checkcard", card=chosen1)
        else:
            textbutton _("(Card 1)") action None
        if chosen2:
            textbutton chosen2.name:
                action ShowTransient("checkcard", card=chosen2)
        else:
            textbutton _("(Card 2)") action None

        null height 10

        if chosen1:
            textbutton _(">Reset Selection"):
                style "fusion_select_button"
                action [ SetVariable("chosen1", None), SetVariable("chosen2", None)]
        else:
            textbutton _(">Reset Selection") action None


    if chosen2:
        textbutton _("Fuse!") action Jump("fusionresult") style "fusion_button" at fusion_appear
    if playcard:
        textbutton _("Play!") action [Hide("checkcard"), Jump("phase2")] style "fusion_button" at play_appear

    frame:# xysize 200, 60:
        xalign .94
        yalign .05
        padding (15,15)
        text _("Deck: ") +str(len(deck))

        #textbutton _("Discard Hand") action [Jump("redraw"), SensitiveIf(len(deck)>0)]

    use hand()

style fusion_select_button:
    background "#dbf4ff"
style fusion_select_button_text:
    selected_idle_color "#aaaaaa"

transform fusion_appear:
    xoffset -200
    easein .3 xoffset 0
transform play_appear:
    xalign 1.0
    xoffset 200
    easein .3 xoffset 0

style fusion_button:
    xsize 340
    ysize 120
    yalign .4
    idle_background Solid("#fff")
    hover_background Solid("#fff9c7")
style fusion_button_text:
    size 68
    bold True
    align (.5,.5)

screen fusion(card1, card2):
    modal True
    if fused:
        add card1.face at fusecard1
        add card2.face at fusecard2
    else:
        add card1.face at fusecardfail1
        add card2.face at fusecardfail2
    timer .5 action Hide('fusion') #on click hide fusion

transform fusecard1:
    align (.3, .5)
    on show:
        yoffset 80 alpha 0
        linear .3 yoffset 0 alpha 1.0
    on hide:
        pause .2

transform fusecard2:
    align (.7, .5)
    on show:
        yoffset 80 alpha 0
        linear .3 yoffset 0 alpha 1.0
    on hide:
        xalign .7
        easeout .15 xalign .3
        "card white"
        alpha 0
        linear .3 alpha 1.0

transform fusecardfail1:
    align (.3, .5)
    on show:
        yoffset 80 alpha 0
        linear .3 yoffset 0 alpha 1.0
    on hide:
        pause .2
        xoffset 0 yoffset 0
        parallel:
            easein .5 xoffset -300
        parallel:
            easeout .5 yoffset 500

transform fusecardfail2:
    align (.7, .5)
    on show:
        yoffset 80 alpha 0
        linear .3 yoffset 0 alpha 1.0
    on hide:
        xalign .7
        easeout .15 xalign .3

init -2 python:
    class Card(store.object):
        def __init__(self, value, name, face, info, cute, cool, type):
            self.value=value
            self.name=name #card title
            self.face=face #card image
            self.info=info #card description
            self.cute=cute #atk value
            self.cool=cool #def value
            self.type=type

    #class Hand(Card):
    #    def __init__(self, value, name, face, info, cute, cool, type, handpos):
    #        Card.__init__(self, value, name, face, info, cute, cool, type)
    #        self.handpos=handpos

#treat chars
default TRT1 = ("TRT1", _("Lonely Wolf Treat"), "card treat",
    _("A quiet and reserved wolf. She loves to eat meat."), 2, 2, "animal")
default MOC1 = ("MOC1", _("Friendly Bunny Mochi"), "card mochi",
    _("A friendly, outgoing bunny. She loves warm meals."), 2, 1, "animal")
default MOX1 = ("MOX1", _("Clever Fox Moxie"), "card moxie",
    _("A fox with an attitude.\nSeems a little dangerous..."), 1, 2, "animal")
default TRK1 = ("TRK1", _("Wandering Wolf Trick"), "card trick",
    _("An adventurous wolf, searching for their friend."), 1, 1, "animal")
default ANM1 = ("ANM1", _("Annie and May"), "card anniemay",
    _("A rabbit and mouse couple, owners of a hot springs inn."), 2, 0, "animal")
default SAP1 = ("SAP1", _("Salt and Pepper"), "card saltpepper",
    _("Moxie's friends. They're a bit of a comedy duo."), 0, 2, "animal")

#treat fusions1
default TRT1MOC1 = ("TRT1MOC1", _("Meal Together"), "card mealtogether",
    _("Curry you made together tastes the best."), 4, 1, "animal")
default MOC1MOX1 = ("MOC1MOX1", _("Nighttime Bathing"), "card nightbath",
    _("Mochi takes Moxie to the hot springs for the first time."), 3, 2, "animal")
default TRT1MOX1 = ("TRT1MOX1", _("Rainy Day"), "card rainyday",
    _("{i}\"Let me walk you home.\"{/i}"), 2, 3, "animal")
default MOC1TRK1 = ("MOC1TRK1", _("Worry!"), "card worry",
    _("{i}\"Did you come here to take Treat back home...?\"{/i}"), 3, 1, "animal")
default TRT1TRK1 = ("TRT1TRK1", _("Staying Up Late"), "card uplate",
    _("{i}\"Tell me another story about somewhere you visited.\"{/i}"), 3, 2, "animal")
    #trick and moxie dont have a fusion
default TRT1ANM1 = ("TRT1ANM1", _("Lunch Break"), "card lunchbreak",
    _("{i}\"You forgot your lunch? Please take some of ours!\"{/i}"), 3, 1, "animal")
default MOX1SAP1 = ("MOX1SAP1", _("Impromptu Performance"), "card impromptuperformance",
    _("{i}\"Welcome to the Foxy Lodge! Ready to solve a mystery?\"{/i}"), 1, 3, "animal")

#treat fusions ult
default MOC1MOX1TRT1 = ("MOC1MOX1TRT1", _("Moxie's Dream"), "card moxiesdream",
    _("{i}\"More kisses for Moxie! More, more!\"{/i}"), 3, 2, "animal")
default MOC1MOX1TRT1TRK1 = ("MOC1MOX1TRT1TRK1", _("Okonomiyaki"), "card okonomiyaki",
    _("A special dinner, where everyone's invited."), 4, 2, "animal")
    #mochi moxie trick fusion?

#field cards
default MTS1 = ("MTS1", _("Mount Sorbet"), "card mtsorbet",
    _("Effect: Adds extra appeal to animal types."), 0, 3, "field")

label card_fusions:

    python:
        fusions = {
            ('MOC1', 'TRT1'): TRT1MOC1,
            ('MOC1', 'MOX1'): MOC1MOX1,
            ('MOX1', 'TRT1'): TRT1MOX1,
            ('TRK1', 'TRT1'): TRT1TRK1,
            ('MOC1', 'TRK1'): MOC1TRK1,
            ('ANM1', 'TRT1'): TRT1ANM1,
            ('MOX1', 'SAP1'): MOX1SAP1,
            ('MOX1', 'TRT1MOC1'): MOC1MOX1TRT1,
            ('MOC1', 'TRT1MOX1'): MOC1MOX1TRT1,
            ('MOC1MOX1', 'TRT1'): MOC1MOX1TRT1,
            ('MOC1MOX1', 'TRT1TRK1'): MOC1MOX1TRT1TRK1,
            ('MOC1TRK1', 'TRT1MOC1'): MOC1MOX1TRT1TRK1,
            ('MOC1TRK1', 'TRT1MOX1'): MOC1MOX1TRT1TRK1,
            ('MOC1MOX1TRT1', 'TRK1'): MOC1MOX1TRT1TRK1,
        }

label card_advantages:

    python:
        advantage = {}

        for i in masterlist:
            if i.type=="animal":
                advantage[i.value] = "MTS1"

    return

label set_masterlist:
    $ masterlist = []

    $ masterlist.append(Card(*TRT1))
    $ masterlist.append(Card(*MOC1))
    $ masterlist.append(Card(*MOX1))
    $ masterlist.append(Card(*TRK1))
    $ masterlist.append(Card(*ANM1))
    $ masterlist.append(Card(*SAP1))

    $ masterlist.append(Card(*TRT1MOC1))
    $ masterlist.append(Card(*TRT1MOX1))
    $ masterlist.append(Card(*MOC1MOX1))
    $ masterlist.append(Card(*MOC1TRK1))
    $ masterlist.append(Card(*TRT1TRK1))
    $ masterlist.append(Card(*TRT1ANM1))
    $ masterlist.append(Card(*MOX1SAP1))

    $ masterlist.append(Card(*MOC1MOX1TRT1))
    $ masterlist.append(Card(*MOC1MOX1TRT1TRK1))

    #field
    $ masterlist.append(Card(*MTS1))
    return
