﻿# The script of the game goes in this file.

# Declare characters used by this game. The color argument colorizes the
# name of the character.

define tut = Character(None, kind=nvl)

# The game starts here.

label start:

    $ _game_menu_screen = "about"

    $ deck = []
    $ yourhand = []

    $ theirdeck = []
    $ theirhand = []

    $ starterdeck = []

    $ wins = 0
    $ losses = 0
    $ rematch = False

    call set_masterlist from _call_set_masterlist
    call card_fusions from _call_card_fusions
    call setdeck from _call_setdeck

    $ quick_menu = False

label cardmenu:
    scene bg cardgame
    $ rematch = False
    $ playingcards = False

    menu:
        "Play cards!!":
            jump cardstart
        "Check rules":
            "i'll add this later sorry"
        "Check winrate":
            "wins: [wins] losses: [losses]"
    jump cardmenu

label tutorial:
    tut "HOW TO PLAY"
    tut "1) pick two cards from your hand to combine into a cute fusion"
    tut "2) if you have a field card you can play it to gain more appeal points for your fusion!"
    tut "3) when you're ready, click play, and your card will be matched against your opponent's fusion."
    tut "4) whoever presents the cutest card wins ;o"
    tut "have fun finding all the combinations! let's begin!"
    nvl clear
    window hide
    $ persistent.tutorial = True

label cardstart:
    if not persistent.tutorial:
        jump tutorial

    scene bg cardgame
    $ playingcards = True

    if not rematch:
        $ deck = []
        call setdeck from _call_setdeck_1
        $ theirdeck = []
        call settheirdeck from _call_settheirdeck
        $ renpy.random.shuffle(deck)
        $ renpy.random.shuffle(theirdeck)

    $ chosen1 = None
    $ chosen2 = None
    $ yourcard = None
    $ fused = False
    $ fieldcard = None
    $ playcard = None

label phase1:
    while len(yourhand) < 5 and len(deck) > 0:
        $ yourhand.append(deck.pop(0))
    while len(theirhand) < 5 and len(theirdeck) > 0:
        $ theirhand.append(theirdeck.pop(0))
    show screen field
    pause

label phase1a:

    #set a card from your hand to the active slot without fusing
    $ playcard = yourcard
    $ yourhand.remove(playcard)

    jump phase1

label fusionresult:
    hide screen field
    $ yourcard = fusions.get(tuple(sorted([chosen1.value, chosen2.value])))

    if yourcard is None: #fusion failed
        $ fused = False
        $ yourcard = chosen2
    else:
        $ fused = True
        $ yourcard = Card(*yourcard)

    show screen fusion(chosen1, chosen2)
    pause 1.5
    hide screen fusion

    if chosen1 in yourhand:
        $ yourhand.remove(chosen1)
    if chosen2 in yourhand and chosen2.type!="field":
        $ yourhand.remove(chosen2)

    if yourcard.type!="field":
        $ playcard = yourcard

    if fused:
        show screen card(playcard)
        pause
        hide screen card

label fusionend:
    $ chosen1 = None
    $ chosen2 = None
    jump phase1

label changefield:
    hide screen field
    $ yourhand.remove(fieldcard)
    $ chosen1 = None
    $ chosen2 = None

    #play whatever animation to show that the field is different
    jump phase1

    #when youve chosen your card it should show the card screen with like light beams around it like THIS IS YOUR GUYYYY then it shows your opponent

label phase2:
    hide screen field

    show opponent
    pause .8
    hide opponent

    $ theirchosen1 = renpy.random.choice(theirhand)
    $ theirhand.remove(theirchosen1)

label phase2a:
    $ theirchosen2 = renpy.random.choice(theirhand)
    if theirchosen2.type=="field": #can't play a field card lol
        jump phase2a

    $ theircard = fusions.get(tuple(sorted([theirchosen1.value, theirchosen2.value])))

    if theircard is None:
        $ fused = False
        $ theircard = theirchosen2
    else:
        $ fused = True
        $ theircard = Card(*theircard)

    show screen fusion(theirchosen1, theirchosen2)
    pause 1.5
    hide screen fusion

    if fused:
        show screen card(theircard)
        pause
        hide screen card

label phase3:

    #time to CALCULATE APPEAL
    $ appeal = yourcard.cute+ yourcard.cool
    $ theirappeal = theircard.cute+ theircard.cool

    #check field card for advantage
    if fieldcard:
        $ fieldbonus = advantage.get(yourcard.value)
        if fieldcard.value == fieldbonus:
            $ appeal +=2

        $ fieldbonus = advantage.get(theircard.value)
        if fieldcard.value == fieldbonus:
            $ theirappeal +=2

    show screen comparecards(yourcard, theircard)

label gameresult:
    if appeal > theirappeal:
        "YOU WIN!"
        $ wins += 1
    elif appeal == theirappeal:
        if len(deck) == 0:
            "Stalemate..."
        else:
            #check if hand and deck arent empty, if they are you forfeit
            "...NEXT ROUND!"
            hide screen comparecards
            $ rematch = True
            window hide
            jump cardstart
    else:
        "You lose..."
        $ losses += 1

    hide screen comparecards
    jump cardmenu

label redraw:
    while len(yourhand) > 0:
        $ yourhand.pop(0)
    jump phase1

label setdeck:
    $ amount = 8
    while amount > 0:
        $ deck.append(Card(*TRT1))
        $ deck.append(Card(*MOC1))
        $ deck.append(Card(*MOX1))
        $ deck.append(Card(*TRK1))
        $ amount -= 1

    $ amount = 2
    while amount > 0:
        $ deck.append(Card(*ANM1))
        $ deck.append(Card(*SAP1))
        $ deck.append(Card(*MTS1))
        $ deck.append(Card(*MTS1))
        $ amount -= 1

    $ starterdeck = deck

    return

label settheirdeck:
    #starter opponent deck
    $ amount = 8
    while amount > 0:
        $ theirdeck.append(Card(*TRT1))
        $ theirdeck.append(Card(*MOC1))
        $ theirdeck.append(Card(*MOX1))
        $ theirdeck.append(Card(*TRK1))
        $ amount -= 1

    $ amount = 2
    while amount > 0:
        $ theirdeck.append(Card(*ANM1))
        $ theirdeck.append(Card(*SAP1))
        $ theirdeck.append(Card(*MTS1))
        $ theirdeck.append(Card(*MTS1))
        $ amount -= 1

    return

#to make a separate copy of deck so you can check it while in a match
#import copy
#$ starterdeck = copy.deepcopy(deck)
